regina::NMarkedAbelianGroup Class Reference
Algebraic Structures

Represents a finitely generated abelian group given by a chain complex. More...

`#include <algebra/nmarkedabeliangroup.h>`

Inheritance diagram for regina::NMarkedAbelianGroup:

## Public Member Functions

| NMarkedAbelianGroup (const NMatrixInt &M, const NMatrixInt &N)
| Creates a marked abelian group from a chain complex. More...
| NMarkedAbelianGroup (const NMatrixInt &M, const NMatrixInt &N, const NLargeInteger &pcoeff)
| Creates a marked abelian group from a chain complex with coefficients in Z_p. More...
| NMarkedAbelianGroup (unsigned long rk, const NLargeInteger &p)
| Creates a free Z_p-module of a given rank using the direct sum of the standard chain complex `0 –> Z –p–> Z –> 0`. More...
| NMarkedAbelianGroup (const NMarkedAbelianGroup &cloneMe)
| Creates a clone of the given group. More...
bool | isChainComplex () const
| Determines whether or not the defining maps for this group actually give a chain complex. More...
| ~NMarkedAbelianGroup ()
| Destroys the group. More...
unsigned long | getRank () const
| Returns the rank of the group. More...
unsigned long | getTorsionRank (const NLargeInteger &degree) const
| Returns the rank in the group of the torsion term of given degree. More...
unsigned long | getTorsionRank (unsigned long degree) const
| Returns the rank in the group of the torsion term of given degree. More...
unsigned long | getNumberOfInvariantFactors () const
| Returns the number of invariant factors that describe the torsion elements of this group. More...
unsigned long | minNumberOfGenerators () const
| Returns the minimum number of generators for the group. More...
const NLargeInteger & | getInvariantFactor (unsigned long index) const
| Returns the given invariant factor describing the torsion elements of this group. More...
bool | isTrivial () const
| Determines whether this is the trivial (zero) group. More...
bool | operator== (const NMarkedAbelianGroup &other) const
| Determines whether this and the given abelian group are isomorphic. More...
bool | isIsomorphicTo (const NMarkedAbelianGroup &other) const
| Determines whether this and the given abelian group are isomorphic. More...
bool | equalTo (const NMarkedAbelianGroup &other) const
| Determines whether or not the two NMarkedAbelianGroups are identical, which means they have exactly the same presentation matrices. More...
void | writeTextShort (std::ostream &out) const
| The text representation will be of the form `3 Z + 4 Z_2 + Z_120`. More...
std::vector< NLargeInteger > | getFreeRep (unsigned long index) const
| Returns the requested free generator in the original chain complex defining the group. More...
std::vector< NLargeInteger > | getTorsionRep (unsigned long index) const
| Returns the requested generator of the torsion subgroup but represented in the original chain complex defining the group. More...
std::vector< NLargeInteger > | ccRep (const std::vector< NLargeInteger > &SNFRep) const
| A combination of getFreeRep and getTorsion rep, this routine takes a vector which represents an element in the group in the SNF coordinates and returns a corresponding vector in the original chain complex. More...
std::vector< NLargeInteger > | ccRep (unsigned long SNFRep) const
| Same as ccRep(const std::vector<NLargeInteger>&), but we assume you only want the chain complex representation of a standard basis vector from SNF coordinates. More...
std::vector< NLargeInteger > | cycleProjection (const std::vector< NLargeInteger > &ccelt) const
| Projects an element of the chain complex to the subspace of cycles. More...
std::vector< NLargeInteger > | cycleProjection (unsigned long ccindx) const
| Projects an element of the chain complex to the subspace of cycles. More...
bool | isCycle (const std::vector< NLargeInteger > &input) const
| Given a vector, determines if it represents a cycle in the chain complex. More...
std::vector< NLargeInteger > | boundaryMap (const std::vector< NLargeInteger > &CCrep) const
| Computes the differential of the given vector in the chain complex whose kernel is the cycles. More...
bool | isBoundary (const std::vector< NLargeInteger > &input) const
| Given a vector, determines if it represents a boundary in the chain complex. More...
std::vector< NLargeInteger > | writeAsBoundary (const std::vector< NLargeInteger > &input) const
| Expresses the given vector as a boundary in the chain complex (if the vector is indeed a boundary at all). More...
unsigned long | getRankCC () const
| Returns the rank of the chain complex supporting the homology computation. More...
std::vector< NLargeInteger > | snfRep (const std::vector< NLargeInteger > &v) const
| Expresses the given vector as a combination of free and torsion generators. More...
std::vector< NLargeInteger > | getSNFIsoRep (const std::vector< NLargeInteger > &v) const
| A deprecated alternative to snfRep(). More...
unsigned long | minNumberCycleGens () const
| Returns the number of generators of ker(M), where M is one of the defining matrices of the chain complex. More...
std::vector< NLargeInteger > | cycleGen (unsigned long i) const
| Returns the ith generator of the cycles, i.e., the kernel of M in the chain complex. More...
const NMatrixInt & | getMRB () const
| Returns a change-of-basis matrix for the Smith normal form of M. More...
const NMatrixInt & | getMRBi () const
| Returns an inverse change-of-basis matrix for the Smith normal form of M. More...
const NMatrixInt & | getMCB () const
| Returns a change-of-basis matrix for the Smith normal form of M. More...
const NMatrixInt & | getMCBi () const
| Returns an inverse change-of-basis matrix for the Smith normal form of M. More...
const NMatrixInt & | getNRB () const
| Returns a change-of-basis matrix for the Smith normal form of the internal presentation matrix. More...
const NMatrixInt & | getNRBi () const
| Returns an inverse change-of-basis matrix for the Smith normal form of the internal presentation matrix. More...
const NMatrixInt & | getNCB () const
| Returns a change-of-basis matrix for the Smith normal form of the internal presentation matrix. More...
const NMatrixInt & | getNCBi () const
| Returns an inverse change-of-basis matrix for the Smith normal form of the internal presentation matrix. More...
unsigned long | getRankM () const
| Returns the rank of the defining matrix M. More...
unsigned long | getFreeLoc () const
| Returns the index of the first free generator in the Smith normal form of the internal presentation matrix. More...
unsigned long | getTorsionLoc () const
| Returns the index of the first torsion generator in the Smith normal form of the internal presentation matrix. More...
const NMatrixInt & | getM () const
| Returns the `right' matrix used in defining the chain complex. More...
const NMatrixInt & | getN () const
| Returns the `left' matrix used in defining the chain complex. More...
const NLargeInteger & | coefficients () const
| Returns the coefficients used for the computation of homology. More...
std::auto_ptr < NMarkedAbelianGroup > | torsionSubgroup () const
| Returns an NMarkedAbelianGroup representing the torsion subgroup of this group. More...
std::auto_ptr < NHomMarkedAbelianGroup > | torsionInclusion () const
| Returns an NHomMarkedAbelianGroup representing the inclusion of the torsion subgroup into this group. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Friends

class | NHomMarkedAbelianGroup

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a finitely generated abelian group given by a chain complex.

This class is initialized with a chain complex. The chain complex is given in terms of two integer matrices M and N such that M*N=0. The abelian group is the kernel of M mod the image of N.

In other words, we are computing the homology of the chain complex `Z^a –N–> Z^b –M–> Z^c` where a=N.columns(), M.columns()=b=N.rows(), and c=M.rows(). An additional constructor allows one to take the homology with coefficients in an arbitrary cyclic group.

This class allows one to retrieve the invariant factors, the rank, and the corresponding vectors in the kernel of M. Moreover, given a vector in the kernel of M, it decribes the homology class of the vector (the free part, and its position in the invariant factors).

The purpose of this class is to allow one to not only represent homology groups, but it gives coordinates on the group allowing for the construction of homomorphisms, and keeping track of subgroups.

Some routines in this class refer to the internal presentation matrix. This is a proper presentation matrix for the abelian group, and is created by constructing the product getMRBi() * N, and then removing the first getRankM() rows.

Author
  Ryan Budney

Todo:

  Optimise (long-term): Look at using sparse matrices for storage of SNF and the like.

  Testsuite additions: isBoundary(), boundaryMap(), writeAsBdry(), cycleGen().

## Constructor & Destructor Documentation

regina::NMarkedAbelianGroup::NMarkedAbelianGroup | ( | const NMatrixInt & | M,
|  | const NMatrixInt & | N
| ) |  |

Creates a marked abelian group from a chain complex.

This constructor assumes you're interested in homology with integer coefficents of the chain complex. Creates a marked abelian group given by the quotient of the kernel of M modulo the image of N.

See the class notes for further details.

Precondition
  M.columns() = N.rows().
  The product M*N = 0.

Parameters

  M | the `right' matrix in the chain complex; that is, the matrix that one takes the kernel of when computing homology.
  N | the `left' matrix in the chain complex; that is, the matrix that one takes the image of when computing homology.

regina::NMarkedAbelianGroup::NMarkedAbelianGroup | ( | const NMatrixInt & | M,
|  | const NMatrixInt & | N,
|  | const NLargeInteger & | pcoeff
| ) |  |

Creates a marked abelian group from a chain complex with coefficients in Z_p.

Precondition
  M.columns() = N.rows().
  The product M*N = 0.

Parameters

  M | the `right' matrix in the chain complex; that is, the matrix that one takes the kernel of when computing homology.
  N | the `left' matrix in the chain complex; that is, the matrix that one takes the image of when computing homology.
  pcoeff | specifies the coefficient ring, Z_pcoeff. We require pcoeff >= 0. If you know beforehand that pcoeff=0, it's more efficient to use the previous constructor.

regina::NMarkedAbelianGroup::NMarkedAbelianGroup | ( | unsigned long | rk,
|  | const NLargeInteger & | p
| ) |  |

Creates a free Z_p-module of a given rank using the direct sum of the standard chain complex `0 –> Z –p–> Z –> 0`.

So this group is isomorphic to `n Z_p`. Moreover, if constructed using the previous constructor, M would be zero and N would be diagonal and square with p down the diagonal.

Parameters

  rk | the rank of the group as a Z_p-module. That is, if the group is `n Z_p`, then rk should be n.
  p | describes the type of ring that we use to talk about the "free" module.

regina::NMarkedAbelianGroup::NMarkedAbelianGroup | ( | const NMarkedAbelianGroup & | cloneMe | ) |

inline

Creates a clone of the given group.

Parameters

  cloneMe | the group to clone.

regina::NMarkedAbelianGroup::~NMarkedAbelianGroup | ( |  | ) |

inline

Destroys the group.

## Member Function Documentation

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::boundaryMap | ( | const std::vector< NLargeInteger > & | CCrep | ) | const

Computes the differential of the given vector in the chain complex whose kernel is the cycles.

In other words, this routine returns `M*CCrep`.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  CCrep | a vector whose length is M.columns(), where M is one of the matrices that defines the chain complex (see the class notes for details).

Returns
  the differential, expressed as a vector of length M.rows().

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::ccRep | ( | const std::vector< NLargeInteger > & | SNFRep | ) | const

A combination of getFreeRep and getTorsion rep, this routine takes a vector which represents an element in the group in the SNF coordinates and returns a corresponding vector in the original chain complex.

This routine is the inverse to snfRep() described below.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  SNFRep | a vector of size the number of generators of the group, i.e., it must be valid in the SNF coordinates. If not, an empty vector is returned.

Returns
  a corresponding vector whose length is M.columns(), where M is one of the matrices that defines the chain complex; see the class notes for details.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::ccRep | ( | unsigned long | SNFRep | ) | const

Same as ccRep(const std::vector<NLargeInteger>&), but we assume you only want the chain complex representation of a standard basis vector from SNF coordinates.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  SNFRep | specifies which standard basis vector from SNF coordinates; this must be between 0 and minNumberOfGenerators()-1 inclusive.

Returns
  a corresponding vector whose length is M.columns(), where M is one of the matrices that defines the chain complex; see the class notes for details.

const NLargeInteger & regina::NMarkedAbelianGroup::coefficients | ( |  | ) | const

inline

Returns the coefficients used for the computation of homology.

That is, this routine returns the integer p where we use coefficients in Z_p. If we use coefficients in the integers Z, then this routine returns 0.

Returns
  the coefficients used in the homology calculation.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::cycleGen | ( | unsigned long | i | ) | const

Returns the ith generator of the cycles, i.e., the kernel of M in the chain complex.

Warning
  The return value may change from version to version of Regina, as it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  i | between 0 and minNumCycleGens()-1.

Returns
  the corresponding generator in chain complex coordinates.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::cycleProjection | ( | const std::vector< NLargeInteger > & | ccelt | ) | const

Projects an element of the chain complex to the subspace of cycles.

Returns an empty vector if the input element does not have dimensions of the chain complex.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  ccelt | a vector whose length is M.columns(), where M is one of the matrices that defines the chain complex (see the class notes for details).

Returns
  a corresponding vector, also in the chain complex coordinates.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::cycleProjection | ( | unsigned long | ccindx | ) | const

Projects an element of the chain complex to the subspace of cycles.

Returns an empty vector if the input index is out of bounds.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  ccindx | the index of the standard basis vector in chain complex coordinates.

Returns
  the resulting projection, in the chain complex coordinates.

bool regina::NMarkedAbelianGroup::equalTo | ( | const NMarkedAbelianGroup & | other | ) | const

inline

Determines whether or not the two NMarkedAbelianGroups are identical, which means they have exactly the same presentation matrices.

This is useful for determining if two NHomMarkedAbelianGroups are composable. See isIsomorphicTo() if all you care about is the isomorphism relation among groups defined by presentation matrices.

Parameters

  other | the NMarkedAbelianGroup with which this should be compared.

Returns
  `true` if and only if the two groups have identical chain-complex definitions.

unsigned long regina::NMarkedAbelianGroup::getFreeLoc | ( |  | ) | const

inline

Returns the index of the first free generator in the Smith normal form of the internal presentation matrix.

See the class overview for details.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the index of the first free generator.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::getFreeRep | ( | unsigned long | index | ) | const

Returns the requested free generator in the original chain complex defining the group.

As described in the class overview, this marked abelian group is defined by matrices M and N where M*N = 0. If M is an m by l matrix and N is an l by n matrix, then this routine returns the (index)th free generator of ker(M)/img(N) in Z^l.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  The return value will be a python list.

Parameters

  index | specifies which free generator to look up; this must be between 0 and getRank()-1 inclusive.

Returns
  the coordinates of the free generator in the nullspace of M; this vector will have length M.columns() (or equivalently, N.rows()). If this generator does not exist, you will receive an empty vector.

const NLargeInteger & regina::NMarkedAbelianGroup::getInvariantFactor | ( | unsigned long | index | ) | const

inline

Returns the given invariant factor describing the torsion elements of this group.

See the NMarkedAbelianGroup class notes for further details.

If the invariant factors are d0|d1|...|dn, this routine will return di where i is the value of parameter index.

Parameters

  index | the index of the invariant factor to return; this must be between 0 and getNumberOfInvariantFactors()-1 inclusive.

Returns
  the requested invariant factor.

const NMatrixInt & regina::NMarkedAbelianGroup::getM | ( |  | ) | const

inline

Returns the `right' matrix used in defining the chain complex.

Our group was defined as the kernel of M mod the image of N. This is the matrix M.

This is a copy of the matrix M that was originally passed to the class constructor. See the class overview for further details on matrices M and N and their roles in defining the chain complex.

Returns
  a reference to the defining matrix M.

const NMatrixInt & regina::NMarkedAbelianGroup::getMCB | ( |  | ) | const

inline

Returns a change-of-basis matrix for the Smith normal form of M.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

Recall from the class overview that this marked abelian group is defined by matrices M and N, where M*N = 0.

- getMCB() * M * getMRB() is the Smith normal form of M;
- getMCBi() and getMRBi() are the inverses of getMCB() and getMRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getMCB() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getMCBi | ( |  | ) | const

inline

Returns an inverse change-of-basis matrix for the Smith normal form of M.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

Recall from the class overview that this marked abelian group is defined by matrices M and N, where M*N = 0.

- getMCB() * M * getMRB() is the Smith normal form of M;
- getMCBi() and getMRBi() are the inverses of getMCB() and getMRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getMCBi() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getMRB | ( |  | ) | const

inline

Returns a change-of-basis matrix for the Smith normal form of M.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

Recall from the class overview that this marked abelian group is defined by matrices M and N, where M*N = 0.

- getMCB() * M * getMRB() is the Smith normal form of M;
- getMCBi() and getMRBi() are the inverses of getMCB() and getMRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getMRB() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getMRBi | ( |  | ) | const

inline

Returns an inverse change-of-basis matrix for the Smith normal form of M.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

Recall from the class overview that this marked abelian group is defined by matrices M and N, where M*N = 0.

- getMCB() * M * getMRB() is the Smith normal form of M;
- getMCBi() and getMRBi() are the inverses of getMCB() and getMRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getMRBi() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getN | ( |  | ) | const

inline

Returns the `left' matrix used in defining the chain complex.

Our group was defined as the kernel of M mod the image of N. This is the matrix N.

This is a copy of the matrix N that was originally passed to the class constructor. See the class overview for further details on matrices M and N and their roles in defining the chain complex.

Returns
  a reference to the defining matrix N.

const NMatrixInt & regina::NMarkedAbelianGroup::getNCB | ( |  | ) | const

inline

Returns a change-of-basis matrix for the Smith normal form of the internal presentation matrix.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

For details on the internal presentation matrix, see the class overview. If P is the internal presentation matrix, then:

- getNCB() * P * getNRB() is the Smith normal form of P;
- getNCBi() and getNRBi() are the inverses of getNCB() and getNRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getNCB() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getNCBi | ( |  | ) | const

inline

Returns an inverse change-of-basis matrix for the Smith normal form of the internal presentation matrix.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

For details on the internal presentation matrix, see the class overview. If P is the internal presentation matrix, then:

- getNCB() * P * getNRB() is the Smith normal form of P;
- getNCBi() and getNRBi() are the inverses of getNCB() and getNRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getNCBi() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getNRB | ( |  | ) | const

inline

Returns a change-of-basis matrix for the Smith normal form of the internal presentation matrix.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

For details on the internal presentation matrix, see the class overview. If P is the internal presentation matrix, then:

- getNCB() * P * getNRB() is the Smith normal form of P;
- getNCBi() and getNRBi() are the inverses of getNCB() and getNRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getNRB() as described above.

const NMatrixInt & regina::NMarkedAbelianGroup::getNRBi | ( |  | ) | const

inline

Returns an inverse change-of-basis matrix for the Smith normal form of the internal presentation matrix.

This is one of several routines that returns information on how we determine the isomorphism-class of this group.

For details on the internal presentation matrix, see the class overview. If P is the internal presentation matrix, then:

- getNCB() * P * getNRB() is the Smith normal form of P;
- getNCBi() and getNRBi() are the inverses of getNCB() and getNRB() respectively.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the matrix getNRBi() as described above.

unsigned long regina::NMarkedAbelianGroup::getNumberOfInvariantFactors | ( |  | ) | const

inline

Returns the number of invariant factors that describe the torsion elements of this group.

This is the minimal number of torsion generators. See the NMarkedAbelianGroup class notes for further details.

Returns
  the number of invariant factors.

unsigned long regina::NMarkedAbelianGroup::getRank | ( |  | ) | const

inline

Returns the rank of the group.

This is the number of included copies of Z.

Returns
  the rank of the group.

unsigned long regina::NMarkedAbelianGroup::getRankCC | ( |  | ) | const

inline

Returns the rank of the chain complex supporting the homology computation.

In the description of this class, this is also given by M.columns() and N.rows() from the constructor that takes as input two matrices, M and N.

Returns
  the rank of the chain complex.

unsigned long regina::NMarkedAbelianGroup::getRankM | ( |  | ) | const

inline

Returns the rank of the defining matrix M.

The matrix M is the `right' matrix used in defining the chain complex. See the class overview for further details.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the rank of the defining matrix M.

std::vector< NLargeInteger > regina::NMarkedAbelianGroup::getSNFIsoRep | ( | const std::vector< NLargeInteger > & | v | ) | const

inline

A deprecated alternative to snfRep().

Deprecated:
  This routine has been renamed to snfRep(). See snfRep() for details, preconditions and warnings.

Python:
  Both v and the return value are python lists.

Parameters

  v | a vector of length M.columns().

Returns
  a vector that describes v in the standard Z_{d1} + ... + Z_{dk} + Z^d form, or the empty vector if v is not in the kernel of M.

unsigned long regina::NMarkedAbelianGroup::getTorsionLoc | ( |  | ) | const

inline

Returns the index of the first torsion generator in the Smith normal form of the internal presentation matrix.

See the class overview for details.

Deprecated:
  This routine will be removed in Regina 5.0.

Returns
  the index of the first torsion generator.

unsigned long regina::NMarkedAbelianGroup::getTorsionRank | ( | const NLargeInteger & | degree | ) | const

Returns the rank in the group of the torsion term of given degree.

If the given degree is d, this routine will return the largest m for which mZ_d is a subgroup of this group.

For instance, if this group is Z_6+Z_12, the torsion term of degree 2 has rank 2 (one occurrence in Z_6 and one in Z_12), and the torsion term of degree 4 has rank 1 (one occurrence in Z_12).

Precondition
  The given degree is at least 2.

Parameters

  degree | the degree of the torsion term to query.

Returns
  the rank in the group of the given torsion term.

unsigned long regina::NMarkedAbelianGroup::getTorsionRank | ( | unsigned long | degree | ) | const

inline

Returns the rank in the group of the torsion term of given degree.

If the given degree is d, this routine will return the largest m for which mZ_d is a subgroup of this group.

For instance, if this group is Z_6+Z_12, the torsion term of degree 2 has rank 2 (one occurrence in Z_6 and one in Z_12), and the torsion term of degree 4 has rank 1 (one occurrence in Z_12).

Precondition
  The given degree is at least 2.

Parameters

  degree | the degree of the torsion term to query.

Returns
  the rank in the group of the given torsion term.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::getTorsionRep | ( | unsigned long | index | ) | const

Returns the requested generator of the torsion subgroup but represented in the original chain complex defining the group.

As described in the class overview, this marked abelian group is defined by matrices M and N where M*N = 0. If M is an m by l matrix and N is an l by n matrix, then this routine returns the (index)th torsion generator of ker(M)/img(N) in Z^l.

Python:
  The return value will be a python list.

Warning
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Parameters

  index | specifies which generator in the torsion subgroup; this must be at least 0 and strictly less than the number of non-trivial invariant factors. If not, you receive an empty vector.

Returns
  the coordinates of the generator in the nullspace of M; this vector will have length M.columns() (or equivalently, N.rows()).

bool regina::NMarkedAbelianGroup::isBoundary | ( | const std::vector< NLargeInteger > & | input | ) | const

Given a vector, determines if it represents a boundary in the chain complex.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  input | a vector whose length is M.columns(), where M is one of the matrices that defines the chain complex (see the class notes for details).

Returns
  `true` if and only if the given vector represents a boundary.

bool regina::NMarkedAbelianGroup::isChainComplex | ( |  | ) | const

Determines whether or not the defining maps for this group actually give a chain complex.

This is helpful for debugging.

Specifically, this routine returns `true` if and only if M*N = 0 where M and N are the definining matrices.

Returns
  `true` if and only if M*N = 0.

bool regina::NMarkedAbelianGroup::isCycle | ( | const std::vector< NLargeInteger > & | input | ) | const

Given a vector, determines if it represents a cycle in the chain complex.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Parameters

  input | an input vector in chain complex coordinates.

Returns
  `true` if and only if the given vector represents a cycle.

bool regina::NMarkedAbelianGroup::isIsomorphicTo | ( | const NMarkedAbelianGroup & | other | ) | const

inline

Determines whether this and the given abelian group are isomorphic.

Parameters

  other | the group with which this should be compared.

Returns
  `true` if and only if the two groups are isomorphic.

bool regina::NMarkedAbelianGroup::isTrivial | ( |  | ) | const

inline

Determines whether this is the trivial (zero) group.

Returns
  `true` if and only if this is the trivial group.

unsigned long regina::NMarkedAbelianGroup::minNumberCycleGens | ( |  | ) | const

inline

Returns the number of generators of ker(M), where M is one of the defining matrices of the chain complex.

Returns
  the number of generators of ker(M).

unsigned long regina::NMarkedAbelianGroup::minNumberOfGenerators | ( |  | ) | const

inline

Returns the minimum number of generators for the group.

Returns
  the minimum number of generators.

bool regina::NMarkedAbelianGroup::operator== | ( | const NMarkedAbelianGroup & | other | ) | const

inline

Determines whether this and the given abelian group are isomorphic.

Deprecated:
  This routine will be removed in a future version of Regina. Users should switch to the less ambiguously named routine isIsomorphicTo() instead.

Parameters

  other | the group with which this should be compared.

Returns
  `true` if and only if the two groups are isomorphic.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::snfRep | ( | const std::vector< NLargeInteger > & | v | ) | const

Expresses the given vector as a combination of free and torsion generators.

This answer is coordinate dependant, meaning the answer may change depending on how the Smith normal form is computed.

Recall that this marked abelian was defined by matrices M and N with M*N=0; suppose that M is an m by l matrix and N is an l by n matrix. This abelian group is then the quotient ker(M)/img(N) in Z^l.

When it is constructed, this group is computed to be isomorphic to some Z_{d0} + ... + Z_{dk} + Z^d, where:

- d is the number of free generators, as returned by getRank();
- d1, ..., dk are the invariant factors that describe the torsion elements of the group, where 1 < d1 | d2 | ... | dk.

This routine takes a single argument v, which must be a vector in Z^l.

If v belongs to ker(M), this routine describes how it projects onto the group ker(M)/img(N). Specifically, it returns a vector of length d + k, where:

- The first k elements describe the projection of v to the torsion component Z_{d1} + ... + Z_{dk}. These elements are returned as non-negative integers modulo d1, ..., dk respectively.
- The remaining d elements describe the projection of v to the free component Z^d.

In other words, suppose v belongs to ker(M) and snfRep(v) returns the vector (b1, ..., bk, a1, ..., ad). Suppose furthermore that the free generators returned by getFreeRep(0..(d-1)) are f1, ..., fd respectively, and that the torsion generators returned by getTorsionRep(0..(k-1)) are t1, ..., tk respectively. Then v = b1.t1 + ... + bk.tk + a1.f1 + ... + ad.fd modulo img(N).

If v does not belong to ker(M), this routine simply returns the empty vector.

Warning
  The return value may change from version to version of Regina, as it depends on the choice of Smith normal form.

Precondition
  Vector v has length M.columns(), or equivalently N.rows().

Python:
  Both v and the return value are python lists.

Parameters

  v | a vector of length M.columns(). M.columns() is also getRankCC().

Returns
  a vector that describes v in the standard Z_{d1} + ... + Z_{dk} + Z^d form, or the empty vector if v is not in the kernel of M. k+d is equal to minNumberOfGenerators().

std::auto_ptr<NHomMarkedAbelianGroup> regina::NMarkedAbelianGroup::torsionInclusion | ( |  | ) | const

Returns an NHomMarkedAbelianGroup representing the inclusion of the torsion subgroup into this group.

std::auto_ptr<NMarkedAbelianGroup> regina::NMarkedAbelianGroup::torsionSubgroup | ( |  | ) | const

Returns an NMarkedAbelianGroup representing the torsion subgroup of this group.

std::vector<NLargeInteger> regina::NMarkedAbelianGroup::writeAsBoundary | ( | const std::vector< NLargeInteger > & | input | ) | const

Expresses the given vector as a boundary in the chain complex (if the vector is indeed a boundary at all).

This routine uses chain complex coordinates for both the input and the return value.

Warning
  If you're using mod-p coefficients and if your element projects to a non-trivial element of TOR, then Nv != input as elements of TOR aren't in the image of N. In this case, input-Nv represents the projection to TOR.
  The return value may change from version to version of Regina, since it depends on the choice of Smith normal form.

Python:
  Not available yet. This routine will be made accessible to Python in a future release.

Returns
  a length zero vector if the input is not a boundary; otherwise a vector v such that `Nv=input`.

void regina::NMarkedAbelianGroup::writeTextShort | ( | std::ostream & | out | ) | const

virtual

The text representation will be of the form `3 Z + 4 Z_2 + Z_120`.

The torsion elements will be written in terms of the invariant factors of the group, as described in the NMarkedAbelianGroup notes.

Parameters

  out | the stream to write to.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- algebra/nmarkedabeliangroup.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).